#include "pieces/cavalier.hpp"

bool Cavalier::est_mouvement_legal(Square org, Square dest) const {
	int row_org, col_org, row_dest, col_dest;
	dest.get_row_col(row_dest, col_dest);
	org.get_row_col(row_org, col_org);

	// Cas de base
	if(!Piece::est_mouvement_legal(org, dest)) return false;
	else{
		// Traitement des 8 cas de déplacement en L du cavalier
		if (abs(row_org - row_dest) == 2 && abs(col_org - col_dest) == 1) return true;
		if (abs(row_org - row_dest) == 1 && abs(col_org - col_dest) == 2) return true;
		return false;
	}
}

bool Cavalier::est_menace(Square org, Square dest) const {
	return est_mouvement_legal(org, dest);
}